int wideness = 1000; 

void setup() {
  size(1000, 500);
}

void draw() {
background(255);
int step = height/25;
  for (int i = 0; i < wideness; i++) {
    color strokeMe = RainBowColor0(i, wideness);
    stroke(strokeMe); 
    
    line(i, 0, i, step*4);

    strokeMe = RainBowColor1(i, wideness);
    stroke(strokeMe); 
    line(i, step*5, i, step*9);

    strokeMe = RainBowColor2(i, wideness);
    stroke(strokeMe); 
    line(i, step*10, i, step*14);
    
    strokeMe = RainBowColor3(i, wideness);
    stroke(strokeMe); 
    line(i, step*15, i, step*19);
    
    strokeMe = RainBowColor4(i, wideness);
    stroke(strokeMe); 
    line(i, step*20, i, step*24);
    
    
    
  }
  fill(128);
  text("RainBowColor0", 10, step*5-5);
  text("RainBowColor1", 10, step*10-5);
  text("RainBowColor2", 10, step*15-5);
  text("RainBowColor3", 10, step*20-5);
  text("RainBowColor4", 10, step*25-5);
}

color RainBowColor0(int data, int maxData)
{
  float i = (data * 255.0 / maxData);
  float r = Math.round(Math.cos(0.024 * i + 0) * 127.0 + 128);
  float g = Math.round(Math.cos(0.024 * i + 2) * 127.0 + 128);
  float b = Math.round(Math.cos(0.024 * i + 4) * 127.0 + 128);
  return color (int(r), int(g), int(b));
}

color RainBowColor1(int data, int maxData)
{
  float i = (data * 255.0 / maxData);
  float r = Math.round(Math.sin(0.105 * i + 0) * 127.0 + 128);
  float g = Math.round(Math.sin(0.101 * i + 2) * 127.0 + 128);
  float b = Math.round(Math.sin(0.087 * i + 4) * 127.0 + 128);
  return color (int(r), int(g), int(b));
}

color RainBowColor2(int data, int maxData)
{
  float i = (data * 255.0 / maxData);
  float r = Math.round(Math.sin(0.024 * i + 0) * 127.0 + 128);
  float g = Math.round(Math.sin(0.024 * i + 2) * 127.0 + 128);
  float b = Math.round(Math.sin(0.024 * i + 4) * 127.0 + 128);
  return color (int(r), int(g), int(b));
}

color RainBowColor3(int data, int maxData)
{
  float i = (data * 255.0 / maxData);
  float factor = 0.006; 
  float r = Math.round(Math.sin(factor * i + 0) * 127.0 + 128);
  float g = Math.round(Math.sin(factor * i + 2) * 127.0 + 128);
  float b = Math.round(Math.sin(factor * i + 4) * 127.0 + 128);
  return color (int(r), int(g), int(b));
}

color RainBowColor4(int data, int maxData)
{
  float i = (data * 255.0 / maxData);
  float factor = 0.020; 
  float offset = 1.0; 
  float r = Math.round(Math.sin(factor * i + 0 + offset) * 127.0 + 147);
  float g = Math.round(Math.sin(factor * i + 2 + offset) * 127.0 + 115);
  float b = Math.round(Math.sin(factor * i + 4 + offset) * 127.0 + 128);
  return color (int(r), int(g), int(b));
}
void keyPressed() {
if (key == 's') {
    //save a frame
    saveFrame("screenCapture"+frameCount+".png"); 
    println("saved frame at "+frameCount);
  }
}
